## Compiling Seed Compiling Seed — How to compile Seed itself |

## Building the Library on UNIX

On UNIX, Seed uses the standard GNU build system, using autoconf for package configuration and resolving portability issues, automake for building makefiles that comply with the GNU Coding Standards, and libtool for building shared libraries on multiple platforms. The normal sequence for compiling and installing Seed is thus:

`./configure`
`make`
`make install`

The standard options provided by GNU autoconf may be passed to the configure script. Please see the autoconf documentation or run ./configure --help for information about the standard options.

## Dependencies

Before you can compile Seed, you need to have various external libraries installed on your system.

- The gobject-introspection library is necessary to build Seed. It provides the bridge between Seed and many GObject-based libraries.

- WebKit provides the JavaScriptCore interpreter, which is fundamental to Seed's ability to execute JavaScript. Seed requires a WebKit SVN revision newer than 35442. Keep in mind that some builds between this and HEAD still won't work with Seed, and performance has only improved, so try to keep an up-to-date version of WebKit if you're planning on working with Seed.

- readline is used by the Seed REPL in order to communicate with the user.

- libffi provides Seed with an interface to call into C libraries at runtime.

- gnome-js-common includes a battery of tests against both Seed and GJS, and also provides numerous libraries of JavaScript functions, including JSON manipulation and various language extensions.

## Module Dependencies

Seed ships with a number of native modules which provide access to libraries which help with development but are not able to be introspected. Some of these modules depend on external libraries, and Seed's configuration will fail if they are not installed; if you wish to build Seed without a module for which you do not have the underlying library installed, check the Extra Configuration Options section of this document.

- Cairo provides access to fast 2D graphics and numerous different types of output, including drawing to the screen, to an image, to a PDF, etc.

- DBus enables Seed to manipulate the various message busses, and provides communication between applications.

- gettext is a common library used for internationalization support.

- libxml2 provides a powerful XML parsing interface.

- mpfr provides multiple-precision arithmetic.

- sqlite3 provides straightforward read-write access to on-disk SQL databases.

## Optional Dependencies

Seed's library of examples utilizes many other GObject projects which Seed does not strictly depend on, and will not be enumerated here. Introspection data for these projects may either be found within the projects themselves, or in the gir-repository.

## Extra Configuration Options

In addition to the normal options, the configure script in the Seed library supports these additional arguments:

`--disable-canvas-module` and `--enable-canvas-module`. By default, and with `--enable-canvas-module` as well, Seed attempts to build the Canvas native module.

`--disable-readline-module` and `--enable-readline-module`. By default, and with `--enable-readline-module` as well, Seed attempts to build the readline native module.

`--disable-multiprocessing-module` and `--enable-multiprocessing-module`. By default, and with `--enable-multiprocessing-module` as well, Seed attempts to build the multiprocessing native module.

`--disable-sqlite-module` and `--enable-sqlite-module`. By default, and with `--enable-sqlite-module` as well, Seed attempts to build the SQLite native module.

`--disable-example-module` and `--enable-example-module`. By default, and with `--enable-example-module` as well, Seed attempts to build the example native module.

`--disable-dbus-module` and `--enable-dbus-module`. By default, and with `--enable-dbus-module` as well, Seed attempts to build the DBus native module.

`--disable-os-module` and `--enable-os-module`. By default, and with `--enable-os-module` as well, Seed attempts to build the os native module.

`--disable-libxml-module` and `--enable-libxml-module`. By default, and with `--enable-libxml-module` as well, Seed attempts to build the libxml2 native module.

`--disable-gtkbuilder-module` and `--enable-gtkbuilder-module`. By default, and with `--enable-gtkbuilder-module` as well, Seed attempts to build the GtkBuilder native module.

`--disable-cairo-module` and `--enable-cairo-module`. By default, and with `--enable-cairo-module` as well, Seed attempts to build the Cairo native module.

`--disable-gettext-module` and `--enable-gettext-module`. By default, and with `--enable-gettext-module` as well, Seed attempts to build the gettext native module.

`--disable-mpfr-module` and `--enable-mpfr-module`. By default, and with `--enable-mpfr-module` as well, Seed attempts to build the mpfr native module.

`--disable-turtle-example` and `--enable-turtle-example`. By default, and with `--enable-turtle-example` as well, Seed attempts to build the Turtle example.

`--disable-examples` and `--enable-examples`. By default, and with `--enable-examples` as well, a library of JavaScript examples are installed alongside Seed.

`--disable-profile` and `--enable-profile`. With `--enable-profile`, Seed is built with profiling and coverage instructions. One can use make profile or make profile-gui to profile the library.

`--disable-profile-modules` and `--enable-profile-modules`. With `--enable-profile-modules`, all Seed modules are built with profiling and coverage instructions. One can use make profile or make profile-gui to profile the modules.

`--disable-debug` and `--enable-debug`. With `--enable-debug`, Seed is built without optimizations and with extra debugging information included, and extra debug arguments to the seed interpreter are enabled; you can learn about these by calling seed --help.

`--disable-shave` and `--enable-shave`. By default, and with `--enable-shave` as well, Seed is built with pretty-printed build output. Disable this to see the actual compiler and linker commands being executed.